//------------------------------------------------------//
//	[AirResistance.cpp]									//
//	CRlR̃eXgvO		//
//	2006.06.06 - 2006.06.06								//
//		Yutaka Yoshisaka								//
//------------------------------------------------------//

/*
	 100 m ̈ʒuA
	a 0.05 m (5cm)̋x0ŎRB
	̂ƂA

	@ ʖx 1000 kg/m^3 ił̎ʖxj̋
	A ʖx  380 kg/m^3 i؍ނł̎ʖxj̋

	̂Q̃p^[ɂāAx̐ڂƒnԂ𒲂ׂĂ݂B
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define V_PI				3.1415926535		// ~
#define V_GRAVITY			9.8					// d͉xim/s^2j
#define V_CD				0.3					// CRW
#define V_P					1.292				// Cx (kg/m^3)
#define V_U					0.000018			// Cł̔S
#define V_SPHERE_R			0.05				// ̂̔a (m)
#define V_DENSITY_WATER		1000.0				// ̎ʖx (kg/m^3)
#define V_DENSITY_WOOD		380.0				// ؍ނ̎ʖx (kg/m^3)

#define V_DT				(1.0 / 30.0)		// 1b30ꍇ̌oߎԁiPʂsecj

//**************************************************************//
//	֐vg^Cv錾										//
//**************************************************************//
double m_func_dv_dt_NoAir(double v, double rS, double r, double m);
double m_func_dv_dt_Air(double v, double rS, double r, double m);

double m_rkCalcV_NoAir(double v, double rS, double r, double m);
double m_rkCalcV_Air(double v, double rS, double r, double m);

//----------------------------------------------//
//	um * (dv/dt) = mgvł					//
//	(dv/dt)߂֐	B						//
//	A͋CRiV					//
//	v  ... x (m/s)							//
//	rS ... ̒fʐ (m^2)						//
//	r  ... ̔a	(m)							//
//	m  ... ̎ (kg)						//
//----------------------------------------------//
double m_func_dv_dt_NoAir(double v, double rS, double r, double m)
{
	return V_GRAVITY;
}

//----------------------------------------------//
//	um * (dv/dt) = mg - CRvł			//
//	(dv/dt)߂֐	B						//
//	͋CRA							//
//	v  ... x (m/s)							//
//	rS ... ̒fʐ (m^2)						//
//	r  ... ̔a (m)							//
//	m  ... ̎ (kg)						//
//----------------------------------------------//
double m_func_dv_dt_Air(double v, double rS, double r, double m)
{
	double Ra, Rb;

	// ŘvZ
	Ra = rS * V_CD * V_P * v * v * 0.5;

	// SŘvZî̏ꍇj
	Rb = 6.0 * V_PI * r * V_U * v;

	return (V_GRAVITY - ((Ra + Rb) / m));
}

//----------------------------------------------//
// x߂֐ (Runge-Kutta@gp)		//
//	͋CRiV							//
//	v  ... x (m/s)							//
//	rS ... ̒fʐ (m^2)						//
//	r  ... ̔a (m)							//
//	m  ... ̎ (kg)						//
//----------------------------------------------//
double m_rkCalcV_NoAir(double v, double rS, double r, double m)
{
	double k1, k2, k3, k4;

	k1 = V_DT * m_func_dv_dt_NoAir(v, rS, r, m);
	k2 = V_DT * m_func_dv_dt_NoAir(v + k1 * 0.5, rS, r, m);
	k3 = V_DT * m_func_dv_dt_NoAir(v + k2 * 0.5, rS, r, m);
	k4 = V_DT * m_func_dv_dt_NoAir(v + k3 , rS, r, m);

	return v + (k1 + 2.0 * k2 + 2.0 * k3 + k4) / 6.0;
}

//----------------------------------------------//
// x߂֐ (Runge-Kutta@gp)		//
//	͋CRA							//
//	v  ... x (m/s)							//
//	rS ... ̒fʐ (m^2)						//
//	r  ... ̔a (m)							//
//	m  ... ̎ (kg)						//
//----------------------------------------------//
double m_rkCalcV_Air(double v, double rS, double r, double m)
{
	double k1, k2, k3, k4;

	k1 = V_DT * m_func_dv_dt_Air(v, rS, r, m);
	k2 = V_DT * m_func_dv_dt_Air(v + k1 * 0.5, rS, r, m);
	k3 = V_DT * m_func_dv_dt_Air(v + k2 * 0.5, rS, r, m);
	k4 = V_DT * m_func_dv_dt_Air(v + k3 , rS, r, m);

	return v + (k1 + 2.0 * k2 + 2.0 * k3 + k4) / 6.0;
}

//**************************************************************//
//	main														//
//**************************************************************//
int main(int argc, char *argv[])
{
	double posY, v, mass, rS, r, t;
	char szStr[256];
	int loop;

	r = V_SPHERE_R;				// ̂̔a
	rS   = V_PI * r * r;		// ̒fʐρi = ar̉~̖ʐρj

	//----------------------------------------------------------//
	//	CRȂꍇ										//
	//----------------------------------------------------------//
	posY = 100.0;				// ̈ʒu
	mass = (4.0 / 3.0) * V_PI * r * r * r * V_DENSITY_WATER;	// ̎ʁix̏ꍇj
	v    = 0.0;					// x

	sprintf(szStr, "---  %f m 甼a %f m ̋̂R ---\n", posY, r);
	printf(szStr);
	printf("̂Ƃ́AuCRȂꍇ́vԂƑx̐ڂvZ܂B\n");

	t = 0.0;
	for(loop = 0; loop < 10000; loop++) {
		sprintf(szStr, "%f sec : x = %f m/s , ʒu = %f m\n", t, v, posY);
		printf(szStr);
		if(posY <= 0.0) break;

		// Runge-Kutta@ɂȂx߂
		v = m_rkCalcV_NoAir(v, rS, r, mass);

		posY -= v * V_DT;	// ʒuXV
		t += V_DT;			// Ԃ(1.0/3.0)bi߂
	}
	printf("\n");

	//----------------------------------------------------------//
	//	CRꍇ										//
	//----------------------------------------------------------//
	posY = 100.0;				// ̈ʒu
	mass = (4.0 / 3.0) * V_PI * r * r * r * V_DENSITY_WATER;	// ̎ʁix̏ꍇj
	v    = 0.0;					// x

	sprintf(szStr, "---  %f m 甼a %f m ̋̂R ---\n", posY, r);
	printf(szStr);
	printf("̂Ƃ́AuCRꍇ́vԂƑx̐ڂvZ܂B\n");

	t = 0.0;
	for(loop = 0; loop < 10000; loop++) {
		sprintf(szStr, "%f sec : x = %f m/s , ʒu = %f m\n", t, v, posY);
		printf(szStr);
		if(posY <= 0.0) break;

		// Runge-Kutta@ɂȂx߂
		v = m_rkCalcV_Air(v, rS, r, mass);

		posY -= v * V_DT;	// ʒuXV
		t += V_DT;			// Ԃ(1.0/3.0)bi߂
	}
	printf("\n");

	//----------------------------------------------------------//
	//	CRꍇɁA									//
	//	ʖxuv̋R					//
	//----------------------------------------------------------//
	posY = 100.0;				// ̈ʒu
	mass = (4.0 / 3.0) * V_PI * r * r * r * V_DENSITY_WATER;	// ̎ʁix̏ꍇj
	v    = 0.0;					// x

	sprintf(szStr, "---  %f m 甼a %f m ̋̂R ---\n", posY, r);
	printf(szStr);
	printf("̂Ƃ́AuCRꍇ́vu̎ʖxi1000 kg/m^3jɂvԂƑx̐ڂvZ܂B\n");

	t = 0.0;
	for(loop = 0; loop < 10000; loop++) {
		sprintf(szStr, "%f sec : x = %f m/s , ʒu = %f m\n", t, v, posY);
		printf(szStr);
		if(posY <= 0.0) break;

		// Runge-Kutta@ɂȂx߂
		v = m_rkCalcV_Air(v, rS, r, mass);

		posY -= v * V_DT;	// ʒuXV
		t += V_DT;			// Ԃ(1.0/3.0)bi߂
	}
	printf("\n");

	//----------------------------------------------------------//
	//	CRꍇɁA									//
	//	ʖxu؍ށv̋R					//
	//----------------------------------------------------------//
	posY = 100.0;				// ̈ʒu
	mass = (4.0 / 3.0) * V_PI * r * r * r * V_DENSITY_WOOD;	// ̎ʁix؍ނ̏ꍇj
	v    = 0.0;					// x

	sprintf(szStr, "---  %f m 甼a %f m ̋̂R ---\n", posY, r);
	printf(szStr);
	printf("̂Ƃ́AuCRꍇ́vu̎ʖx؍ށi380 kg/m^3jɂvԂƑx̐ڂvZ܂B\n");

	t = 0.0;
	for(loop = 0; loop < 10000; loop++) {
		sprintf(szStr, "%f sec : x = %f m/s , ʒu = %f m\n", t, v, posY);
		printf(szStr);
		if(posY <= 0.0) break;

		// Runge-Kutta@ɂȂx߂
		v = m_rkCalcV_Air(v, rS, r, mass);

		posY -= v * V_DT;	// ʒuXV
		t += V_DT;			// Ԃ(1.0/3.0)bi߂
	}
	printf("\n");

	return 0;
}
